#include "tuya_iot_config.h"
#include "tuya_cloud_types.h"
#include "tuya_cloud_com_defs.h"
#include "tal_thread.h"
#include "tal_log.h"
#include "tal_system.h"
#include "tuya_cloud_types.h"
#include "tuya_svc_netmgr.h"
#if defined(ENABLE_WIFI_SERVICE) && (ENABLE_WIFI_SERVICE == 1)
#include "tuya_iot_wifi_api.h"
#endif
#if defined(ENABLE_WIRED) && (ENABLE_WIRED == 1)
#include "tuya_iot_base_api.h"
#endif
#include "tuya_iot_com_api.h"
#include "tuya_ws_db.h"

#include "tal_system.h"
#include "tal_log.h"
#include "base_event.h"
#include "tal_semaphore.h"
#include "tal_thread.h"
#include "tkl_uart.h"

#define PID         "uiiyltkjmkhwumga"
#define UUID        "uuid8c979a2cea91955c"
#define AUTHKEY     "8TxpnLMkuovxRtlh5TfICLipjzZKnc07"
static void uart2_isr_callback(int port_id)
{
    uint32_t rx_char = 0;
    int ret;
    while (1)
    {
        rx_char = 0;
        ret = tkl_uart_read(port_id, &rx_char, 1);
        if (!ret) {
            bk_printf("%s:%d ret %d\r\n", "uart2_isr_callback", __LINE__, ret);
            break;
        }
        bk_printf("%s:%d rx_char 0x%x ret %d\r\n", "uart2_isr_callback", __LINE__, rx_char, ret);
    }
}
STATIC VOID user_main(VOID_T)
{
    OPERATE_RET ret;
    TY_IOT_CBS_S iot_cbs = {0};
    TY_INIT_PARAMS_S init_param = {0};
    WF_GW_PROD_INFO_S prod_info = {UUID, AUTHKEY};
    init_param.init_db = TRUE;
    strcpy(init_param.sys_env, TARGET_PLATFORM);
    ret = tuya_iot_init_params(NULL, &init_param);
    if(ret!=OPRT_OK){
        TAL_PR_ERR("iot soc init error:%d",ret);
        return;
    }

    tuya_iot_set_wf_gw_prod_info(&prod_info);

    
    tkl_uart_rx_irq_cb_reg(1, uart2_isr_callback);

    while(1) {
        TAL_PR_DEBUG("Hello TuyaOS.");
        tal_system_sleep(3000);  // 3s
    }

    return;
}

THREAD_HANDLE ty_app_thread = NULL;
STATIC VOID tuya_app_thread(VOID_T *arg )
{
    user_main();

    tal_thread_delete(ty_app_thread);
    ty_app_thread = NULL;
}

/**
 * @brief user entry function
 *
 * @param[in] none
 *
 * @return none
 */
#if OPERATING_SYSTEM == SYSTEM_LINUX
INT_T main(INT_T argc, CHAR_T **argv)
#else
VOID_T tuya_app_main(VOID)
#endif
{
    THREAD_CFG_T thrd_param = {4096, 4, "tuya_app_main"};
    tal_thread_create_and_start(&ty_app_thread, NULL, NULL, tuya_app_thread, NULL, &thrd_param);
#if OPERATING_SYSTEM == SYSTEM_LINUX
    while (1) {
        tal_system_sleep(1000);
    }
#endif
}
